/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program
  
 Author    : Peter Deak (hyperr@freemail.hu)
 License   : GPL
 Copyright : (C) 2003 Peter Deak
****************************************************************************/

#include "adddialog.h"
#include "guibase.h"

#include <qvariant.h>
#include <qcombobox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qmultilineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qfile.h>
#include <qdir.h>
#include <qfileinfo.h>
#include <qpainter.h>
#include <qdatetime.h>

#include "dirview.h"
#include "icons.h"
#include "dbase.h"
#include "mainwidget.h"
#include "config.h"
#include <qmessagebox.h>

addDialog::addDialog(GuiSlave *c, QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    int i;
    QString tm;

    caller = c;
    if ( !name )
	setName( "addDialog" );

    setSizeGripEnabled(TRUE);
    addDialogLayout = new QGridLayout( this, 1, 1, 11, 6, "addDialogLayout");

    layout10 = new QVBoxLayout( 0, 0, 6, "layout10");

    layout9 = new QHBoxLayout( 0, 0, 6, "layout9");

    layout8 = new QVBoxLayout( 0, 0, 6, "layout8");

    textLabel6 = new QLabel( this, "textLabel6" );
    layout8->addWidget( textLabel6 );

    dirView = new DirectoryView( this,0);
    dirView->resize(190,210);
    dirView->setGeometry( QRect( 10, 40, 190, 210 ) );
    dirView->setCaption(tr("Directory Browser"));


    layout8->addWidget( dirView );
    layout9->addLayout( layout8 );

    layout7 = new QVBoxLayout( 0, 0, 6, "layout7");

    textLabel1 = new QLabel( this, "textLabel1" );
    layout7->addWidget( textLabel1 );

    leName = new QLineEdit( this, "leName" );
    layout7->addWidget( leName );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2");

    textLabel2 = new QLabel( this, "textLabel2" );
    layout2->addWidget( textLabel2 );

    sbNumber = new QSpinBox( this, "sbNumber" );
    layout2->addWidget( sbNumber );
    layout7->addLayout( layout2 );

    layout3 = new QHBoxLayout( 0, 0, 6, "layout3");

    textLabel4 = new QLabel( this, "textLabel4" );
    layout3->addWidget( textLabel4 );

    cbType = new QComboBox( FALSE, this, "cbType" );
    layout3->addWidget( cbType );
    layout7->addLayout( layout3 );

    layout4 = new QHBoxLayout( 0, 0, 6, "layout4");

    textLabel5 = new QLabel( this, "textLabel5" );
    layout4->addWidget( textLabel5 );

    leOwner = new QLineEdit( this, "leOwner" );
    layout4->addWidget( leOwner );
    layout7->addLayout( layout4 );

    layout5 = new QGridLayout( 0, 1, 1, 0, 6, "layout5");

    textLabel3 = new QLabel( this, "textLabel3" );

    layout5->addWidget( textLabel3, 0, 0 );

    teComm = new QMultiLineEdit( this, "teComm" );

    layout5->addMultiCellWidget( teComm, 0, 1, 1, 1 );
    QSpacerItem* spacer = new QSpacerItem( 20, 60, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout5->addItem( spacer, 1, 0 );
    layout7->addLayout( layout5 );
    layout9->addLayout( layout7 );
    layout10->addLayout( layout9 );

    layout1 = new QHBoxLayout( 0, 0, 6, "layout1");
    QSpacerItem* spacer_2 = new QSpacerItem( 90, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer_2 );

    buttonOK = new QPushButton( this, "buttonOk" );
    buttonOK->setMinimumWidth(100);
    layout1->addWidget( buttonOK );

    buttonCancel = new QPushButton( this, "buttonCancel" );
    buttonCancel->setMinimumWidth(100);
    layout1->addWidget( buttonCancel );
    QSpacerItem* spacer_3 = new QSpacerItem( 110, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer_3 );
    layout10->addLayout( layout1 );

    addDialogLayout->addLayout( layout10, 0, 0 );
    languageChange();
    resize( QSize(454, 350).expandedTo(minimumSizeHint()) );

  /*  textLabel6 = new QLabel( this, "textLabel6" );
    textLabel6->setGeometry( QRect( 10, 20, 200, 20 ) );

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 220, 0, 70, 20 ) );

    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setGeometry( QRect( 220, 50, 130, 20 ) );

    textLabel5 = new QLabel( this, "textLabel5" );
    textLabel5->setGeometry( QRect( 220, 110, 60, 20 ) );

    textLabel4 = new QLabel( this, "textLabel4" );
    textLabel4->setGeometry( QRect( 220, 80, 30, 20 ) );

    textLabel3 = new QLabel( this, "textLabel3" );
    textLabel3->setGeometry( QRect( 220, 140, 62, 20 ) );

    buttonCancel = new QPushButton( this, "buttonCancel" );
    buttonCancel->setGeometry( QRect( 220, 270, 98, 25 ) );

    buttonOK = new QPushButton( this, "buttonOK" );
    buttonOK->setGeometry( QRect( 110, 270, 98, 25 ) );

    teComm = new QMultiLineEdit( this, "teComm" );
    teComm->setGeometry( QRect( 220, 160, 200, 90 ) );

    dirView = new DirectoryView( this,0);
    dirView->resize(190,210);
    dirView->setGeometry( QRect( 10, 40, 190, 210 ) );
    dirView->setCaption(tr("Directory Browser"));

    leOwner = new QLineEdit( this, "leOwner" );
    leOwner->setGeometry( QRect( 280, 110, 130, 20 ) );

    cbType = new QComboBox( FALSE, this, "cbType" );
    cbType->setGeometry( QRect( 260, 80, 160, 26 ) );

    sbNumber = new QSpinBox(0,20000,1,this, "sbNumber" );
    sbNumber->setGeometry( QRect( 360, 50, 55, 20 ) );

    leName = new QLineEdit( this, "leName" );
    leName->setGeometry( QRect( 220, 20, 190, 20 ) );
    languageChange();
    resize( QSize(434, 310).expandedTo(minimumSizeHint()) );
    setMinimumSize(434, 310);
    setMaximumSize(434, 310);

*/

    connect(buttonOK,SIGNAL(clicked()),this,SLOT(bOk()));
    connect(buttonCancel,SIGNAL(clicked()),this,SLOT(bCan()));

    for(i=1;!caller->isIdentical(i);i++);
    sbNumber->setValue(i);
    tm =tr("New Disk %1").arg(i);
    leName->setText(tm);

//    cbType->setCurrentText(tr( "CD" )); // default

    if (cbType->currentItem()+1 == CD || cbType->currentItem()+1 == DVD)
     {
        dirView->setDir(((CdCatMainWidget *)parent)->cconfig->cdrompath);
        dirView->sDir=((CdCatMainWidget *)parent)->cconfig->cdrompath;
     }
}

/*
 *  Destroys the object and frees any allocated resources
 */
addDialog::~addDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void addDialog::languageChange()
{
    setCaption( tr( "Add Media to the Database" ) );
    textLabel6->setText( tr( "Choose a directory to scan:" ) );
    textLabel1->setText( tr( "Media Name:" ) );
    textLabel2->setText( tr( "Serial number of Media:" ) );
    textLabel5->setText( tr( "Owner:" ) );
    textLabel4->setText( tr( "Type:" ) );
    textLabel3->setText( tr( "Comment:" ) );
    buttonCancel->setText( tr( "Cancel" ) );
    buttonOK->setText( tr( "OK / Scan" ) );
    cbType->clear();
    cbType->insertItem( *get_m_cd_icon(), tr( "CD" ) );
    cbType->insertItem( *get_m_dvd_icon(), tr( "DVD" ) );
    cbType->insertItem( *get_m_hdd_icon(), tr( "HardDisc" ) );
    cbType->insertItem( *get_m_floppy_icon(), tr( "Floppy" ) );
    cbType->insertItem( *get_m_net_icon(), tr( "NetworkPlace" ) );
    cbType->insertItem( *get_m_flash_icon(), tr( "FlashDrive" ) );
    cbType->insertItem( *get_m_other_icon(), tr( "OtherDevice" ) );
//    cbType->setCurrentText(tr( "CD" )); // default
}

int addDialog::bOk(void)
 {
  if((leName->text()).isEmpty())
   {
    QMessageBox::warning(this,tr("Error:"),tr("You must be fill the \"Name\" field!"),tr("Ok"),0);
    return 0;
   }
  if(!caller->isIdentical(leName->text()))
   {
    QMessageBox::warning(this,tr("Error:"),tr("The Media Name must be identical! Please change it!")
                         ,tr("Ok"),0);
    return 0;
   }
  if(!caller->isIdentical(sbNumber->value()))
   {
    QMessageBox::warning(this,tr("Error:"),tr("The Value of Serial Number must be identical! Please change the value!")
                         ,tr("Ok"),0);
    return 0;
   }

  if(dirView->sDir.isEmpty())
   {
    QMessageBox::warning(this,tr("Error:"),tr("You aren't selected a directory! Please select one!")
                         ,tr("Ok"),0);
    return 0;
   }


  OK = 1;
  type   = cbType->currentItem()+1;
  serial = sbNumber->value();
  dName  = leName->text();
  dOwner = leOwner->text();
  dComm  = teComm->text();
  dDir   = dirView->sDir;

  close();
  return 0;
 }

int addDialog::bCan(void)
 {
  OK = 0;
  close();
  return 0;
 }


/**************************************************************************/
  
PWw::PWw(QWidget *parent) : QWidget(parent,"PleaseWaitBox",
#ifdef QT_NO_COMPAT 
      WType_Dialog | WStyle_Customize | WStyle_NoBorder | WShowModal
#else
      WType_Modal  | WStyle_Customize | WStyle_NoBorder 
#endif      
     )
     {
       setMinimumSize(80,68);
       setMaximumSize(80,68);
       
       setGeometry(parent->x()+((parent->width()-80)/2),
                   parent->y()+((parent->height()-68)/2),
		   80,
		   68);

       t=QTime::currentTime(); 
       s=0;   
       show();
     }

void PWw::end(void)
    {
      close();
    }

void PWw::step(void)
    {
      if(!isActiveWindow()) show();
      repaint();     
    }

void PWw::paintEvent(QPaintEvent *e)
    {
     QTime tt;
     tt=QTime::currentTime();
     if(t.msecsTo(tt) < 100) return;
     t =tt;
     
     QPainter p(this);

     p.setClipping(FALSE);
     p.drawRect(1,1,78,66);
     p.drawText(10,18,tr("Please Wait..."));
     p.drawPixmap(20,25,*(get_anim(s)));
     
     p.flush();
     if(++s==5) s=0;     
    }

void progress(PWw *p)
 {
  if(p != NULL)
  p->step();
 }

