/****************************************************************************
                             Hyper's CD Catalog 
		A multiplatform qt and xml based catalog program
  
 Author    : Peter Deak (hyperr@freemail.hu)
 License   : GPL
 Copyright : (C) 2003 Peter Deak
****************************************************************************/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <qtranslator.h>
#include <qtextcodec.h>
#include <qfont.h>
#include <qapplication.h>

#include "dbase.h"
#include "cdcat.h"
#include "config.h"
#include "mainwidget.h"
#include "icons.h"

int main(int argi,char **argc)
 {
  int font_size=8;
  QApplication app(argi,argc);
  static QTranslator *translator = 0;
  CdCatConfig *cconfig = new CdCatConfig();

  if(cconfig->readConfig() == 0)
    font_size = cconfig->fsize;
  else
    cconfig->writeConfig();

  QFont *font=new QFont();
  
  font->setPointSize(font_size);

#ifdef _WIN32
  QString lang("./lang.qm");
#else

  QString lang("cdcat_en.qm");
  QString dir(getenv("QTDIR"));
  if (dir.isEmpty())
    dir="/usr/lib/qt3/";
  dir = dir + "/translations/";
  lang=dir + "cdcat_" + QTextCodec::locale() + ".qm";

#endif

  if ( translator ) {
       app.removeTranslator( translator );
       delete translator;
    }
    
  translator = new QTranslator( 0 );
  translator->load( lang, "." );

  app.installTranslator( translator );
  
  init_icon_base();
  
  CdCatMainWidget *mw = new CdCatMainWidget (cconfig,&app,0,"MainWindow");
  
  app.setFont(*font,TRUE);
  app.setMainWidget( mw );
  
  mw->show();
  return app.exec();
 }
 
char *mstr(const char *imp)
 {
  char *x;
  if(imp == NULL) return NULL;
  x = new char[strlen(imp)+1];
  strcpy(x,imp);
  return x;
 } 

