/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program

 Author    : Peter Deak (hyperr@freemail.hu)
 License   : GPL
 Copyright : (C) 2003 Peter Deak
****************************************************************************/

#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H

#include <qstring.h>
#include <qvariant.h>
#include <qobject.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QCheckBox;
class QLineEdit;
class QPushButton;
class DataBase;
class QLabel;
class QWidget;
class CdCatMainWidget;
class QSpinBox;
class QFrame;

class CdCatConfig : public QObject
 {
  Q_OBJECT
  public:
   char errormsg[512];

   CdCatConfig(void);

   int startProgram(DataBase **dbp,QWidget *mw);
   int writeConfig();
   int readConfig ();

  public: //Configureable items:
   int     fsize;
   bool    autoload;
   QString autoloadfn;
   bool    nice;
   QString cdrompath;
#ifndef _WIN32
   bool    mounteject;
#endif

 };

/*****************************************************************************/

class ConfigDialog : public QDialog
{
    Q_OBJECT

public:
    ConfigDialog( CdCatMainWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~ConfigDialog();

    CdCatMainWidget *p;
    QLineEdit* filename;
    QPushButton* searchButton;
    QFrame* line1;
    QSpinBox* spinbox;
    QLabel* lab;
    QCheckBox* cbNice;
    QLineEdit* cdrompath_lineedit;
    QLabel* cdrom_lab;
    QFrame* line2;
    QFrame* line3;
    QFrame* line4;
    QPushButton* okButton;
    QPushButton* cancelButton;
    QCheckBox* cbAutoload;

protected:
    QGridLayout* ConfigDialogBaseLayout;
    QHBoxLayout* layout3;
    QHBoxLayout* layout4;
    QHBoxLayout* layout5;
    QHBoxLayout* layout6;

#ifndef _WIN32
    QFrame* line5;
    QCheckBox* cbMoEj;
#endif


public slots:
    virtual void okExit();
    virtual void ffdbutton();

protected:

protected slots:
    virtual void languageChange();
};

#endif // CONFIGDIALOG_H
