/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program

 Author    : Christoph Thielecke (crissi99@gmx.de)
 License   : GPL
 Copyright : (C) 2003 Christoph Thielecke
****************************************************************************/

#ifndef IMPORT__
#define IMPORT__


#include <qobject.h>
#include <qlistview.h>
#include <qfiledialog.h>
#include <qwidget.h>
#include <qdatetime.h>
#include <qlist.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "guibase.h"
#include "dbase.h"

#ifndef _WIN32
#ifndef _OLD_QT_
class QProcess;
#endif
#endif

class Node;
class CdCatMainWidget;

class lineObject:public QObject {
  Q_OBJECT public:

    /*
     * @param medianame Name of media @param path Full path of file.
     * Example: folder1/subfolder/subsubfolder/file @param size Size of
     * file @param date Date of file @param time Mod time of file
     */
     lineObject(QString medianame, QString path, QString filename,
		float size, QDateTime datetime);
    ~lineObject();

    QString getMediaName();
    QString getPath();
    QString getFileName();
    float getSize();
    QDateTime getDateTime();

  protected:
    QString medianame;
    QString path;
    QString filename;
    QDateTime datetime;
    float size;
   };


class importCsv:public QObject {
  Q_OBJECT public:
     importCsv(GuiSlave * parent);
    ~importCsv();

    /*
     * @param medianame Name of media @param path Full path of file.
     * Example: folder1/subfolder/subsubfolder/file @param size Size of
     * file @param datetime Date + time of file
     */
    int addNewItem(QString medianame, QString path, QString filename,
		   float size, QDateTime datetime);

    /*
     * @param new_medianame Name of new media
     */
    int addNewMedia(QString new_medianame,
		    QList < lineObject > *medialines);

  protected:
     GuiSlave * guislave;
     QList < lineObject > *medialines;
     DataBase *db;
     int mediacount;
     int filecount;
     int dircount;
     int refreshcount;
     bool createdatabase;
     bool correctbadstyle;
};


#endif
