/****************************************************************************
                             Hyper's CD Catalog
		A multiplatform qt and xml based catalog program

 Author    : Christoph Thielecke (crissi99@gmx.de)
 License   : GPL
 Copyright : (C) 2003 Christoph Thielecke
****************************************************************************/

#ifndef IMPORTDIALOG_H
#define IMPORTDIALOG_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qdialog.h>
#include <qdatetime.h>
#include <qcheckbox.h>
#include <qlayout.h>


class QLabel;
class QLineEdit;
class QPushButton;

class ImportDialog : public QDialog
{
    Q_OBJECT

public:
    ImportDialog(QWidget* parent=0, const char* name=0, bool modal=true, WFlags fl=0 );
    ~ImportDialog();


    QLabel* filename_lab;
    QLabel* seperator_lab;
    QLabel* info_lab;

    QPushButton* buttonCancel;
    QPushButton* buttonOK;
    QPushButton* buttonGetFile;
    QLineEdit* filename_lineedit;
    QLineEdit* seperator_lineedit;
    QCheckBox *newdatabase;
    QCheckBox *correctbadstyle;


protected:
 QGridLayout* layout4;
 QGridLayout* ImportDialogLayout;

protected slots:
    virtual void languageChange();
    int bOk();
    int bCan();
    void getFileName();

private:


public:
    int OK;
    QString filename,seperator;
    bool createdatabase;

};

#endif // IMPORTDIALOG_H
