/****************************************************************************
                             Hyper's CD Catalog 
		A multiplatform qt and xml based catalog program
  
 Author    : Peter Deak (hyperr@freemail.hu)
 License   : GPL
 Copyright : (C) 2003 Peter Deak
****************************************************************************/

#include "mp3tag.h"
#include <string.h>
#include <stdio.h>

unsigned char found_error;

char * ReadMp3Tag::strbcut(char *a) //Oly used by A ReadTAG function
 {
  for(int i=strlen(a)-1;i>0;i--)
   if(a[i] != ' ')
    {
     a[i+1]='\0';
     return a;
    }
   a[1]='\0';
   return a;
 }


int ReadMp3Tag::ReadTAG(const char *filename)
 {
  FILE *mp3=NULL;

//cerr<<"Load file: "<<filename<<" ...";
  if( (mp3 = fopen(filename,"rb"))==NULL)
   {
     bTAGreaded = 1;
     bTAGexist  = 0;
     found_error = 1;
     fprintf(stderr,"I can't open a .mp3 file: %s\n",filename);
     return -1;
   }
   //         X AL AR TI TAG
   fseek(mp3,-128,SEEK_END);
   strcpy(TAG,"");
   fread(TAG,sizeof(char),3,mp3);   
   TAG[3]='\0';
   if(strcmp(TAG,"TAG"))
    {
      bTAGexist =0;
      bTAGreaded=1;
      fclose(mp3);
      return -2; //Id3 tag not exists
    }
   else
    {
     fread(Title ,sizeof(char),30,mp3);  Title  [30]='\0';
     fread(Artist,sizeof(char),30,mp3);  Artist [30]='\0';
     fread(Album ,sizeof(char),30,mp3);  Album  [30]='\0';
     fread(Year ,sizeof(char),4,mp3);    Year   [4 ]='\0';
     fread(Comment,sizeof(char),30,mp3); Comment[30]='\0';

     tnumber = 0;
     if(Comment[28] == 0) 
      {
       tnumber = Comment[29];
       Comment[28] = '\0'; 
      }

     strbcut(Artist);
     strbcut(Title);
     strbcut(Year);
     strbcut(Album);
     strbcut(Comment);

     bTAGreaded=1;
     bTAGexist =1;
    }
    fclose(mp3);
    return 1;
 }

